Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 812)
+++ .hgsubstate	(revision 843)
@@ -1,1 +1,1 @@
-8a3e66573699ef9cf6f96d16bed8015a380dd17c inc/libs/clearbricks
+4f62679e0756104bdc0b49eacaed9aba68735aa5 inc/libs/clearbricks
Index: .hgtags
===================================================================
--- .hgtags	(revision 827)
+++ .hgtags	(revision 800)
@@ -6,3 +6,2 @@
 0000000000000000000000000000000000000000 2.4.2
 6b3942c0cf7eee71ebd906ec0827c5962823dedf 2.4.2
-36578fa779919f730e714e10041b1f896e56a8f4 2.4.3
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 826)
+++ inc/prepend.php	(revision 801)
@@ -123,5 +123,5 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.4.3');
+define('DC_VERSION','2.5-dev');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
Index: plugins/attachments/_define.php
===================================================================
--- plugins/attachments/_define.php	(revision 464)
+++ plugins/attachments/_define.php	(revision 843)
@@ -18,5 +18,5 @@
 	/* Version */		'1.0',
 	array(
-		'permissions' =>	'contentadmin,pages',
+		'permissions' =>	'usage,contentadmin,pages',
 		'priority' =>		999
 	)
Index: plugins/importExport/_admin.php
===================================================================
--- plugins/importExport/_admin.php	(revision 324)
+++ plugins/importExport/_admin.php	(revision 840)
@@ -2,7 +2,7 @@
 # -- BEGIN LICENSE BLOCK ---------------------------------------
 #
-# This file is part of Dotclear 2.
+# This file is part of importExport, a plugin for DotClear2.
 #
-# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2012 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -12,12 +12,11 @@
 if (!defined('DC_CONTEXT_ADMIN')) { return; }
 
-$_menu['Plugins']->addItem(__('Import/Export'),'plugin.php?p=importExport','index.php?pf=importExport/icon.png',
-		preg_match('/plugin.php\?p=importExport(&.*)?$/',$_SERVER['REQUEST_URI']),
-		$core->auth->check('admin',$core->blog->id));
-
-# Files needed by flat files import / export
-$__autoload['backupFile'] = dirname(__FILE__).'/inc/flat/class.backupFile.php';
-$__autoload['dcImport'] = dirname(__FILE__).'/inc/flat/class.dc.import.php';
-$__autoload['dbExport'] = dirname(__FILE__).'/inc/flat/class.db.export.php';
+$_menu['Plugins']->addItem(
+	__('Import/Export'),
+	'plugin.php?p=importExport',
+	'index.php?pf=importExport/icon.png',
+	preg_match('/plugin.php\?p=importExport(&.*)?$/',$_SERVER['REQUEST_URI']),
+	$core->auth->check('admin',$core->blog->id)
+);
 
 $core->addBehavior('adminDashboardFavs','importExportDashboardFavs');
@@ -25,7 +24,12 @@
 function importExportDashboardFavs($core,$favs)
 {
-	$favs['importExport'] = new ArrayObject(array('importExport','Import/Export','plugin.php?p=importExport',
-		'index.php?pf=importExport/icon.png','index.php?pf=importExport/icon-big.png',
-		'admin',null,null));
+	$favs['importExport'] = new ArrayObject(array(
+		'importExport',
+		__('Import/Export'),
+		'plugin.php?p=importExport',
+		'index.php?pf=importExport/icon.png',
+		'index.php?pf=importExport/icon-big.png',
+		'admin',null,null
+	));
 }
 ?>
Index: plugins/importExport/_define.php
===================================================================
--- plugins/importExport/_define.php	(revision 464)
+++ plugins/importExport/_define.php	(revision 841)
@@ -2,7 +2,7 @@
 # -- BEGIN LICENSE BLOCK ---------------------------------------
 #
-# This file is part of Dotclear 2.
+# This file is part of importExport, a plugin for DotClear2.
 #
-# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2012 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -15,10 +15,7 @@
 	/* Name */			"Import / Export",
 	/* Description*/		"Import and Export your blog",
-	/* Author */			"Olivier Meunier",
-	/* Version */			'2.4',
-	array(
-		'permissions' => 'admin',
-		'priority' => 10
-	)
+	/* Author */			"Olivier Meunier & Contributors",
+	/* Version */			'3.1',
+	/* Perm */			'admin'
 );
 ?>
Index: plugins/importExport/_prepend.php
===================================================================
--- plugins/importExport/_prepend.php	(revision 840)
+++ plugins/importExport/_prepend.php	(revision 840)
@@ -0,0 +1,42 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of importExport, a plugin for DotClear2.
+#
+# Copyright (c) 2003-2012 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+
+$__autoload['dcIeModule'] = 	dirname(__FILE__).'/inc/class.dc.ieModule.php';
+
+$__autoload['dcImportFlat'] = 	dirname(__FILE__).'/inc/class.dc.import.flat.php';
+$__autoload['dcImportFeed'] = 	dirname(__FILE__).'/inc/class.dc.import.feed.php';
+
+$__autoload['dcExportFlat'] = 	dirname(__FILE__).'/inc/class.dc.export.flat.php';
+
+$__autoload['dcImportDC1'] = 	dirname(__FILE__).'/inc/class.dc.import.dc1.php';
+$__autoload['dcImportWP'] = 	dirname(__FILE__).'/inc/class.dc.import.wp.php';
+
+$__autoload['flatBackup'] = 	dirname(__FILE__).'/inc/flat/class.flat.backup.php';
+$__autoload['flatImport'] = 	dirname(__FILE__).'/inc/flat/class.flat.import.php';
+$__autoload['flatExport'] = 	dirname(__FILE__).'/inc/flat/class.flat.export.php';
+
+$core->addBehavior('importExportModules','registerIeModules');
+
+function registerIeModules($modules)
+{
+	$modules['import'][] = 'dcImportFlat';
+	$modules['import'][] = 'dcImportFeed';
+	
+	$modules['export'][] = 'dcExportFlat';
+	
+	if ($GLOBALS['core']->auth->isSuperAdmin()) {
+		$modules['import'][] = 'dcImportDC1';
+		$modules['import'][] = 'dcImportWP';
+	}
+}
+?>
Index: plugins/importExport/inc/class.dc.export.flat.php
===================================================================
--- plugins/importExport/inc/class.dc.export.flat.php	(revision 557)
+++ plugins/importExport/inc/class.dc.export.flat.php	(revision 840)
@@ -2,7 +2,7 @@
 # -- BEGIN LICENSE BLOCK ---------------------------------------
 #
-# This file is part of Dotclear 2.
+# This file is part of importExport, a plugin for DotClear2.
 #
-# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2012 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -16,5 +16,5 @@
 	public function setInfo()
 	{
-		$this->type = 'e';
+		$this->type = 'export';
 		$this->name = __('Flat file export');
 		$this->description = __('Exports a blog or a full Dotclear installation to flat file.');
@@ -31,5 +31,5 @@
 			try
 			{
-				$exp = new dbExport($this->core->con,$fullname,$this->core->prefix);
+				$exp = new flatExport($this->core->con,$fullname,$this->core->prefix);
 				fwrite($exp->fp,'///DOTCLEAR|'.DC_VERSION."|single\n");
 				
@@ -84,4 +84,5 @@
 				$_SESSION['export_file'] = $fullname;
 				$_SESSION['export_filename'] = $_POST['file_name'];
+				$_SESSION['export_filezip'] = !empty($_POST['file_zip']);
 				http::redirect($this->getURL().'&do=ok');
 			}
@@ -99,5 +100,5 @@
 			try
 			{
-				$exp = new dbExport($this->core->con,$fullname,$this->core->prefix);
+				$exp = new flatExport($this->core->con,$fullname,$this->core->prefix);
 				fwrite($exp->fp,'///DOTCLEAR|'.DC_VERSION."|full\n");
 				$exp->exportTable('blog');
@@ -123,4 +124,5 @@
 				$_SESSION['export_file'] = $fullname;
 				$_SESSION['export_filename'] = $_POST['file_name'];
+				$_SESSION['export_filezip'] = !empty($_POST['file_zip']);
 				http::redirect($this->getURL().'&do=ok');
 			}
@@ -140,11 +142,47 @@
 			
 			ob_end_clean();
-			header('Content-Disposition: attachment;filename='.$_SESSION['export_filename']);
-			header('Content-Type: text/plain; charset=UTF-8');
-			readfile($_SESSION['export_file']);
-			unlink($_SESSION['export_file']);
-			unset($_SESSION['export_file']);
-			unset($_SESSION['export_filename']);
-			exit;
+			
+			if (substr($_SESSION['export_filename'],-4) == '.zip') {
+				$_SESSION['export_filename'] = substr($_SESSION['export_filename'],0,-4);//.'.txt';
+			}
+			
+			# Flat export
+			if (empty($_SESSION['export_filezip'])) {
+			
+				header('Content-Disposition: attachment;filename='.$_SESSION['export_filename']);
+				header('Content-Type: text/plain; charset=UTF-8');
+				readfile($_SESSION['export_file']);
+				
+				unlink($_SESSION['export_file']);
+				unset($_SESSION['export_file'],$_SESSION['export_filename'],$_SESSION['export_filezip']);
+				exit;
+			}
+			# Zip export
+			else {
+				try
+				{
+					$file_zipname = $_SESSION['export_filename'].'.zip';
+					
+					$fp = fopen('php://output','wb');
+					$zip = new fileZip($fp);
+					$zip->addFile($_SESSION['export_file'],$_SESSION['export_filename']);
+					
+					header('Content-Disposition: attachment;filename='.$file_zipname);
+					header('Content-Type: application/x-zip');
+					
+					$zip->write();
+					
+					unlink($_SESSION['export_file']);
+					unset($zip,$_SESSION['export_file'],$_SESSION['export_filename'],$file_zipname);
+					exit;
+				}
+				catch (Exception $e)
+				{
+					unset($zip,$_SESSION['export_file'],$_SESSION['export_filename'],$file_zipname);
+					@unlink($_SESSION['export_file']);
+					
+					throw new Exception(__('Failed to compress export file.'));
+				}
+			}
 		}
 	}
@@ -154,15 +192,25 @@
 		echo
 		'<form action="'.$this->getURL(true).'" method="post">'.
-		'<fieldset><legend>'.__('Export a blog').'</legend>'.
-		'<p>'.sprintf(__('This will create an export of your current blog: %s'),
-		'<strong>'.html::escapeHTML($this->core->blog->name).'</strong>').'</p>'.
-		'<p><label for="file_name" class="classic">'.__('File name:').'</label>'.
-		form::field(array('file_name','file_name'),25,255,date('Y-m-d-').html::escapeHTML($this->core->blog->id.'-backup.txt')).
-		'<input type="submit" value="'.__('Export').'" />'.
+		'<fieldset><legend>'.__('Single blog').'</legend>'.
+		'<p>'.sprintf(__('This will create an export of your current blog: %s'),html::escapeHTML($this->core->blog->name)).'</p>'.
+		
+		'<p><label for="file_name">'.__('File name:').'</label>'.
+		form::field(array('file_name','file_name'),50,255,date('Y-m-d-').html::escapeHTML($this->core->blog->id.'-backup.txt')).
+		'</p>'.
+		
+		'<p><label for="file_zip" class="classic">'.
+		form::checkbox(array('file_zip','file_zip'),1).' '.
+		__('Compress file').'</label>'.
+		'</p>'.
+		
+		'<p class="zip-dl"><a href="media.php?d=&amp;zipdl=1">'.
+		__('You may also want to download your media directory as a zip file').'</a></p>'.
+		
+		'<p><input type="submit" value="'.__('Export').'" />'.
 		form::hidden(array('do'),'export_blog').
 		$this->core->formNonce().'</p>'.
-		'<p class="zip-dl"><a href="media.php?d=&amp;zipdl=1">'.
-		__('You may also want to download your media directory as a zip file').'</a></p>'.
-		'</fieldset></form>';
+		
+		'</fieldset>'.
+		'</form>';
 		
 		if ($this->core->auth->isSuperAdmin())
@@ -170,11 +218,22 @@
 			echo
 			'<form action="'.$this->getURL(true).'" method="post">'.
-			'<fieldset><legend>'.__('Export all content').'</legend>'.
-			'<p><label for="file_name2" class="classic">'.__('File name:').'</label>'.
-			form::field(array('file_name','file_name2'),25,255,date('Y-m-d-').'dotclear-backup.txt').
-			'<input type="submit" value="'.__('Export all content').'" />'.
+			'<fieldset><legend>'.__('Multiple blogs').'</legend>'.
+			'<p>'.__('This will create an export of all the content of your database.').'</p>'.
+			
+			'<p><label for="file_name2">'.__('File name:').'</label>'.
+			form::field(array('file_name','file_name2'),50,255,date('Y-m-d-').'dotclear-backup.txt').
+			'</p>'.
+			
+			'<p><label for="file_zip2" class="classic">'.
+			form::checkbox(array('file_zip','file_zip2'),1).' '.
+			__('Compress file').'</label>'.
+			'</p>'.
+			
+			'<p><input type="submit" value="'.__('Export').'" />'.
 			form::hidden(array('do'),'export_all').
 			$this->core->formNonce().'</p>'.
-			'</fieldset></form>';
+			
+			'</fieldset>'.
+			'</form>';
 		}
 	}
Index: plugins/importExport/inc/class.dc.ieModule.php
===================================================================
--- plugins/importExport/inc/class.dc.ieModule.php	(revision 270)
+++ plugins/importExport/inc/class.dc.ieModule.php	(revision 840)
@@ -2,7 +2,7 @@
 # -- BEGIN LICENSE BLOCK ---------------------------------------
 #
-# This file is part of Dotclear 2.
+# This file is part of importExport, a plugin for DotClear2.
 #
-# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2012 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -12,5 +12,5 @@
 if (!defined('DC_RC_PATH')) { return; }
 
-class dcIeModule
+abstract class dcIeModule
 {
 	public $type;
@@ -28,14 +28,14 @@
 		$this->setInfo();
 		
-		$this->id = get_class($this);
-		if (!$this->type) {
-			throw new Exception('No type for module'.$this->id);
+		if (!in_array($this->type,array('import','export'))) {
+			throw new Exception(sprintf('Unknow type for module %s',get_class($this)));
 		}
-		
-		$this->url = 'plugin.php?p=importExport&t='.$this->type.'&f='.$this->id;
 		
 		if (!$this->name) {
 			$this->name = get_class($this);
 		}
+		
+		$this->id = get_class($this);
+		$this->url = sprintf('plugin.php?p=importExport&type=%s&module=%s',$this->type,$this->id);
 	}
 	
@@ -44,23 +44,14 @@
 	}
 	
-	protected function setInfo()
-	{
-	}
+	abstract protected function setInfo();
 	
 	final public function getURL($escape=false)
 	{
-		if ($escape) {
-			return html::escapeHTML($this->url);
-		}
-		return $this->url;
+		return $escape ? html::escapeHTML($this->url) : $this->url;
 	}
 	
-	public function process($do)
-	{
-	}
+	abstract public function process($do);
 	
-	public function gui()
-	{
-	}
+	abstract public function gui();
 	
 	protected function progressBar($percent)
Index: plugins/importExport/inc/class.dc.import.dc1.php
===================================================================
--- plugins/importExport/inc/class.dc.import.dc1.php	(revision 270)
+++ plugins/importExport/inc/class.dc.import.dc1.php	(revision 840)
@@ -2,7 +2,7 @@
 # -- BEGIN LICENSE BLOCK ---------------------------------------
 #
-# This file is part of Dotclear 2.
+# This file is part of importExport, a plugin for DotClear2.
 #
-# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2012 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -40,5 +40,5 @@
 	protected function setInfo()
 	{
-		$this->type = 'i';
+		$this->type = 'import';
 		$this->name = __('Dotclear 1.2 import');
 		$this->description = __('Import a Dotclear 1.2 installation into your current blog.');
Index: plugins/importExport/inc/class.dc.import.feed.php
===================================================================
--- plugins/importExport/inc/class.dc.import.feed.php	(revision 557)
+++ plugins/importExport/inc/class.dc.import.feed.php	(revision 840)
@@ -2,7 +2,7 @@
 # -- BEGIN LICENSE BLOCK ---------------------------------------
 #
-# This file is part of Dotclear 2.
+# This file is part of importExport, a plugin for DotClear2.
 #
-# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2012 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -19,5 +19,5 @@
 	public function setInfo()
 	{
-		$this->type = 'i';
+		$this->type = 'import';
 		$this->name = __('Feed import');
 		$this->description = __('Imports a feed as new entries.');
@@ -81,16 +81,17 @@
 		
 		echo
-		'<h3>'.__('Import from a feed').'</h3>'.
-		'<p>'.sprintf(__('This will import a feed (RSS or Atom) a as new content in the current blog: %s.'),
-		'<strong>'.html::escapeHTML($this->core->blog->name).'</strong>').'</p>'.
 		'<form action="'.$this->getURL(true).'" method="post">'.
+		'<fieldset><legend>'.__('Single blog').'</legend>'.
+		'<p>'.sprintf(__('This will import a feed (RSS or Atom) a as new content in the current blog: %s.'),html::escapeHTML($this->core->blog->name)).'</p>'.
 		
-		'<div class="fieldset">'.
+		'<p><label for="feed_url">'.__('Feed URL:').'</label>'.
+		form::field('feed_url',50,300,html::escapeHTML($this->feed_url)).'</p>'.
+		
+		'<p>'.
 		$this->core->formNonce().
 		form::hidden(array('do'),1).
-		'<p><label for="feed_url">'.__('Feed URL:').'</label>'.
-		form::field('feed_url',40,300,html::escapeHTML($this->feed_url)).'</p>'.
-		'<p><input type="submit" value="'.__('Import').'" /></p>'.
-		'</div>'.
+		'<input type="submit" value="'.__('Import').'" /></p>'.
+		
+		'</fieldset>'.
 		'</form>';
 	}
Index: plugins/importExport/inc/class.dc.import.flat.php
===================================================================
--- plugins/importExport/inc/class.dc.import.flat.php	(revision 557)
+++ plugins/importExport/inc/class.dc.import.flat.php	(revision 840)
@@ -2,7 +2,7 @@
 # -- BEGIN LICENSE BLOCK ---------------------------------------
 #
-# This file is part of Dotclear 2.
+# This file is part of importExport, a plugin for DotClear2.
 #
-# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2012 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -18,5 +18,5 @@
 	public function setInfo()
 	{
-		$this->type = 'i';
+		$this->type = 'import';
 		$this->name = __('Flat file import');
 		$this->description = __('Imports a blog or a full Dotclear installation from flat file.');
@@ -55,7 +55,17 @@
 			
 			try {
-				$bk = new dcImport($this->core,$file);
+				# Try to unzip file
+				$unzip_file = $this->unzip($file);
+				if (false !== $unzip_file) {
+					$bk = new flatImport($this->core,$unzip_file);
+				}
+				# Else this is a normal file
+				else {
+					$bk = new flatImport($this->core,$file);
+				}
+				
 				$bk->importSingle();
 			} catch (Exception $e) {
+				@unlink($unzip_file);
 				if ($to_unlink) {
 					@unlink($file);
@@ -63,4 +73,5 @@
 				throw $e;
 			}
+			@unlink($unzip_file);
 			if ($to_unlink) {
 				@unlink($file);
@@ -95,7 +106,17 @@
 			
 			try {
-				$bk = new dcImport($this->core,$file);
+				# Try to unzip file
+				$unzip_file = $this->unzip($file);
+				if (false !== $unzip_file) {
+					$bk = new flatImport($this->core,$unzip_file);
+				}
+				# Else this is a normal file
+				else {
+					$bk = new flatImport($this->core,$file);
+				}
+				
 				$bk->importFull();
 			} catch (Exception $e) {
+				@unlink($unzip_file);
 				if ($to_unlink) {
 					@unlink($file);
@@ -103,4 +124,5 @@
 				throw $e;
 			}
+			@unlink($unzip_file);
 			if ($to_unlink) {
 				@unlink($file);
@@ -128,4 +150,7 @@
 			return;
 		}
+		
+		$public_files = array_merge(array('-' => ''),$this->getPublicFiles());
+		$has_files = (boolean) (count($public_files) - 1);
 		
 		echo
@@ -155,29 +180,27 @@
 		
 		echo
-		'<h3>'.__('Import a single blog').'</h3>'.
-		'<p>'.sprintf(__('This will import a single blog backup as new content in the current blog: %s.'),
-		'<strong>'.html::escapeHTML($this->core->blog->name).'</strong>').'</p>'.
 		'<form action="'.$this->getURL(true).'" method="post" enctype="multipart/form-data">'.
-		
-		'<div class="fieldset">'.
+		'<fieldset><legend>'.__('Single blog').'</legend>'.
+		'<p>'.sprintf(__('This will import a single blog backup as new content in the current blog: %s.'),html::escapeHTML($this->core->blog->name)).'</p>'.
+		
+		'<p><label for="up_single_file">'.__('Upload a backup file').'</label>'.
+		'<input type="file" id="up_single_file" name="up_single_file" size="20" />'.
+		'</p>';
+		
+		if ($has_files) {
+			echo 
+			'<p><label for="public_single_file">'.__('or pick up a local file in your public directory').' '.
+			form::combo('public_single_file',$public_files).
+			'</label></p>';
+		}
+		
+		echo 
+		'<p>'.
 		$this->core->formNonce().
 		form::hidden(array('do'),1).
 		form::hidden(array('MAX_FILE_SIZE'),DC_MAX_UPLOAD_SIZE).
-		'<p><label for="up_single_file">'.__('Upload a backup file').'</label>'.
-		'<input type="file" id="up_single_file" name="up_single_file" size="20" />'.
-		'</p>';
-		
-		$public_files = $this->getPublicFiles();
-		
-		$empty = empty($public_files);
-		$public_files = array_merge(array('-' => ''),$public_files);
-		echo
-		'<p><label for="public_single_file">'.__('or pick up a local file in your public directory').' '.
-		form::combo('public_single_file',$public_files, '', '', '', $empty).
-		'</label></p>';
-		
-		echo
-		'<p><input type="submit" value="'.__('Import').'" /></p>'.
-		'</div>'.
+		'<input type="submit" value="'.__('Import').'" /></p>'.
+		
+		'</fieldset>'.
 		'</form>';
 		
@@ -185,29 +208,30 @@
 		{
 			echo
-			'<h3>'.__('Import a full backup file').'</h3>'.
 			'<form action="'.$this->getURL(true).'" method="post" enctype="multipart/form-data" id="formfull">'.
-			'<div>'.form::hidden(array('MAX_FILE_SIZE'),DC_MAX_UPLOAD_SIZE).'</div>'.
-			
-			'<div class="fieldset">'.
+			'<fieldset><legend>'.__('Multiple blogs').'</legend>'.
+			'<p>'.__('This will reset all the content of your database, except users.').'</p>'.
+			
+			'<p><label for="up_full_file">'.__('Upload a backup file').'</label>'.
+			'<input type="file" id="up_full_file" name="up_full_file" size="20" />'.
+			'</p>';
+			
+			if ($has_files) {
+				echo 
+				'<p><label for="public_full_file">'.__('or pick up a local file in your public directory').'</label>'.
+				form::combo('public_full_file',$public_files).
+				'</p>';
+			}
+			
+			echo
+			'<p><label for="your_pwd" class="required"><abbr title="'.__('Required field').'">*</abbr> '.__('Your password:').'</label>'.
+			form::password('your_pwd',20,255).'</p>'.
+			
+			'<p>'.
 			$this->core->formNonce().
 			form::hidden(array('do'),1).
 			form::hidden(array('MAX_FILE_SIZE'),DC_MAX_UPLOAD_SIZE).
-			'<p><label for="up_full_file">'.__('Upload a backup file').'</label>'.
-			'<input type="file" id="up_full_file" name="up_full_file" size="20" />'.
-			'</p>';
-			
-			echo
-			'<p><label for="public_full_file">'.__('or pick up a local file in your public directory').'</label>'.
-			form::combo('public_full_file',$public_files, '', '', '', $empty).
-			'</p>';
-			
-			echo
-			'<p class="form-note warning"><strong>'.__('Warning: This will reset all the content of your database, except users.').'</strong></p>'.
-			
-			'<p><label for="your_pwd" class="required"><abbr title="'.__('Required field').'">*</abbr> '.__('Your password:').'</label>'.
-			form::password('your_pwd',20,255).'</p>'.
-			
-			'<p><input type="submit" value="'.__('Import').'" /></p>'.
-			'</div>'.
+			'<input type="submit" value="'.__('Import').'" /></p>'.
+			
+			'</fieldset>'.
 			'</form>';
 		}
@@ -225,13 +249,76 @@
 				if (is_file($entry_path) && is_readable($entry_path))
 				{
-					$fp = fopen($entry_path,'rb');
-					if (strpos(fgets($fp),'///DOTCLEAR|') === 0) {
+					# Do not test each zip file content here, its too long
+					if (substr($entry_path,-4) == '.zip') {
+							$public_files[$entry] = $entry_path;
+					}
+					elseif (self::checkFileContent($entry_path)) {
 						$public_files[$entry] = $entry_path;
 					}
-					fclose($fp);
 				}
 			}
 		}
 		return $public_files;
+	}
+	
+	protected static function checkFileContent($entry_path)
+	{
+		$ret = false;
+		
+		$fp = fopen($entry_path,'rb');
+		$ret = strpos(fgets($fp),'///DOTCLEAR|') === 0;
+		fclose($fp);
+		
+		return $ret;
+	}
+	
+	private function unzip($file)
+	{
+		$zip = new fileUnzip($file);
+		
+		if ($zip->isEmpty()) {
+			$zip->close();
+			return false;//throw new Exception(__('File is empty or not a compressed file.'));
+		}
+		
+		foreach($zip->getFilesList() as $zip_file)
+		{
+			# Check zipped file name
+			if (substr($zip_file,-4) != '.txt') {
+				continue;
+			}
+			
+			# Check zipped file contents
+			$content = $zip->unzip($zip_file);
+			if (strpos($content,'///DOTCLEAR|') !== 0) {
+				unset($content);
+				continue;
+			}
+			
+			$target = path::fullFromRoot($zip_file,dirname($file));
+			
+			# Check existing files with same name
+			if (file_exists($target)) {
+				$zip->close();
+				unset($content);
+				throw new Exception(__('Another file with same name exists.'));
+			}
+			
+			# Extract backup content
+			if (file_put_contents($target,$content) === false) {
+				$zip->close();
+				unset($content);
+				throw new Exception(__('Failed to extract backup file.'));
+			}
+			
+			$zip->close();
+			unset($content);
+			
+			# Return extracted file name
+			return $target;
+		}
+		
+		$zip->close();
+		throw new Exception(__('No backup in compressed file.'));
 	}
 }
Index: plugins/importExport/inc/class.dc.import.wp.php
===================================================================
--- plugins/importExport/inc/class.dc.import.wp.php	(revision 807)
+++ plugins/importExport/inc/class.dc.import.wp.php	(revision 840)
@@ -2,7 +2,7 @@
 # -- BEGIN LICENSE BLOCK ---------------------------------------
 #
-# This file is part of Dotclear 2.
+# This file is part of importExport, a plugin for DotClear2.
 #
-# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2012 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -61,5 +61,5 @@
 	protected function setInfo()
 	{
-		$this->type = 'i';
+		$this->type = 'import';
 		$this->name = __('WordPress import');
 		$this->description = __('Import a WordPress installation into your current blog.');
Index: plugins/importExport/inc/flat/class.flat.backup.php
===================================================================
--- plugins/importExport/inc/flat/class.flat.backup.php	(revision 841)
+++ plugins/importExport/inc/flat/class.flat.backup.php	(revision 841)
@@ -0,0 +1,148 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of importExport, a plugin for DotClear2.
+#
+# Copyright (c) 2003-2012 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+
+class flatBackup
+{
+	protected $fp;
+	private $line_cols = array();
+	private $line_name;
+	private $line_num;
+	
+	private $replacement = array(
+		'/(?<!\\\\)(?>(\\\\\\\\)*+)(\\\\n)/u' => "\$1\n",
+		'/(?<!\\\\)(?>(\\\\\\\\)*+)(\\\\r)/u' => "\$1\r",
+		'/(?<!\\\\)(?>(\\\\\\\\)*+)(\\\\")/u' => '$1"',
+		'/(\\\\\\\\)/' => '\\'
+	);
+	
+	public function __construct($file)
+	{
+		if (file_exists($file) && is_readable($file)) {
+			$this->fp = fopen($file,'rb');
+			$this->line_num = 1;
+		} else {
+			throw new Exception(__('No file to read.'));
+		}
+	}
+	
+	public function __destruct()
+	{
+		if ($this->fp) {
+			fclose($this->fp);
+		}
+	}
+	
+	public function getLine()
+	{
+		if (($line = $this->nextLine()) === false) {
+			return false;
+		}
+		
+		if (substr($line,0,1) == '[')
+		{
+			$this->line_name = substr($line,1,strpos($line,' ')-1);
+			
+			$line = substr($line,strpos($line,' ')+1,-1);
+			$this->line_cols = explode(',',$line);
+			
+			return $this->getLine();
+		}
+		elseif (substr($line,0,1) == '"')
+		{
+			$line = preg_replace('/^"|"$/','',$line);
+			$line = preg_split('/(^"|","|"$)/m',$line);
+			
+			if (count($this->line_cols) != count($line)) {
+				throw new Exception(sprintf('Invalid row count at line %s',$this->line_num));
+			}
+			
+			$res = array();
+			
+			for ($i=0; $i<count($line); $i++) {
+				$res[$this->line_cols[$i]] =
+				preg_replace(array_keys($this->replacement),array_values($this->replacement),$line[$i]);
+			}
+			
+			return new flatBackupItem($this->line_name,$res,$this->line_num);
+		}
+		else
+		{
+			return $this->getLine();
+		}
+	}
+	
+	private function nextLine()
+	{
+		if (feof($this->fp)) {
+			return false;
+		}
+		$this->line_num++;
+		
+		$line = fgets($this->fp);
+		$line = trim($line);
+		
+		return empty($line) ? $this->nextLine() : $line;
+	}
+}
+
+class flatBackupItem
+{
+	public $__name;
+	public $__line;
+	private $__data = array();
+	
+	public function __construct($name,$data,$line)
+	{
+		$this->__name = $name;
+		$this->__data = $data;
+		$this->__line = $line;
+	}
+	
+	public function f($name)
+	{
+		return iconv('UTF-8','UTF-8//IGNORE',$this->__data[$name]);
+	}
+	
+	public function __get($name)
+	{
+		return $this->f($name);
+	}
+	
+	public function __set($n,$v)
+	{
+		$this->__data[$n] = $v;
+	}
+	
+	public function exists($n)
+	{
+		return isset($this->__data[$n]);
+	}
+	
+	public function drop()
+	{
+		foreach (func_get_args() as $n) {
+			if (isset($this->__data[$n])) {
+				unset($this->__data[$n]);
+			}
+		}
+	}
+	
+	public function substitute($old,$new)
+	{
+		if (isset($this->__data[$old])) {
+			$this->__data[$new] = $this->__data[$old];
+			unset($this->__data[$old]);
+		}
+	}
+}
+?>
Index: plugins/importExport/inc/flat/class.flat.export.php
===================================================================
--- plugins/importExport/inc/flat/class.flat.export.php	(revision 840)
+++ plugins/importExport/inc/flat/class.flat.export.php	(revision 840)
@@ -0,0 +1,106 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of importExport, a plugin for DotClear2.
+#
+# Copyright (c) 2003-2012 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+
+class flatExport
+{
+	private $con;
+	private $prefix;
+	
+	private $line_reg = array('/\\\\/u',  '/\n/u','/\r/u','/"/u');
+	private $line_rep = array('\\\\\\\\', '\n'   ,'\r'   ,'\"');
+	
+	public $fp;
+	
+	function __construct($con,$out='php://output',$prefix=null)
+	{
+		$this->con =& $con;
+		$this->prefix = $prefix;
+		
+		if (($this->fp = fopen($out,'w')) === false) {
+			return false;
+		}
+		@set_time_limit(300);
+	}
+	
+	function __destruct()
+	{
+		if (is_resource($this->fp)) {
+			fclose($this->fp);
+		}
+	}
+	
+	function export($name,$sql)
+	{
+		$rs = $this->con->select($sql);
+		
+		if (!$rs->isEmpty())
+		{
+			fwrite($this->fp,"\n[".$name.' '.implode(',',$rs->columns())."]\n");
+			while ($rs->fetch()) {
+				fwrite($this->fp,$this->getLine($rs));
+			}
+			fflush($this->fp);
+		}
+	}
+	
+	function exportAll()
+	{
+		$tables = $this->getTables();
+		
+		foreach ($tables as $table)
+		{
+			$this->exportTable($table);
+		}
+	}
+	
+	function exportTable($table)
+	{
+		$req = 'SELECT * FROM '.$this->con->escapeSystem($this->prefix.$table);
+		
+		$this->export($table,$req);
+	}
+	
+	function getTables()
+	{
+		$schema = dbSchema::init($this->con);
+		$db_tables = $schema->getTables();
+		
+		$tables = array();
+		foreach ($db_tables as $t)
+		{
+			if ($this->prefix) {
+				if (strpos($t,$this->prefix) === 0) {
+					$tables[] = $t;
+				}
+			} else {
+				$tables[] = $t;
+			}
+		}
+		
+		return $tables;
+	}
+	
+	function getLine($rs)
+	{
+		$l = array();
+		$cols = $rs->columns();
+		foreach ($cols as $i => &$c) {
+			$s = $rs->f($c);
+			$s = preg_replace($this->line_reg,$this->line_rep,$s);
+			$s = '"'.$s.'"';
+			$l[$i] = $s;
+		}
+		return implode(',',$l)."\n";
+	}
+}
+?>
